/*
Copyright (C) 2020 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2017 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once

#include <Windows.h>

class CCommandLineInfo
{
public:
    typedef enum tagOperation
    {
        Operation_NONE=0,
        Operation_SAVE,
        Operation_RESTORE,
    };

    tagOperation Operation;
    TCHAR* pFilePath;
    BOOL bVerbose; // display msg box on success

    CCommandLineInfo()
    {
        this->Operation = Operation_NONE;
        this->pFilePath = NULL;
        this->bVerbose = FALSE;
    }

    ~CCommandLineInfo()
    {
        this->FreeFilePath();
    }

    void FreeFilePath()
    {
        if (this->pFilePath)
        {
            free(this->pFilePath);
            this->pFilePath = NULL;
        }
    }
};

BOOL ParseCommandLine(OUT BOOL* pbHasParams,IN OUT CCommandLineInfo* pCommandLineInfo);